## cherrytree 0.39.3

=== future/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.13.2)

project(cherrytree)
set(CT_VERSION "0.1.0")


# used to install locale, packagers might overwrite this
if(NOT PACKAGE_LOCALE_DIR)
  set(PACKAGE_LOCALE_DIR "share/locale") 
endif(NOT PACKAGE_LOCALE_DIR)

# used to install data, packagers might overwrite this
if(NOT SHARE_INSTALL)
  set(SHARE_INSTALL "share" CACHE STRING "Data file install path. Must be a relative path (from CMAKE_INSTALL_PREFIX), with no trailing slash.")
endif(NOT SHARE_INSTALL)
set(CHERRYTREE_SHARE_INSTALL "${SHARE_INSTALL}/cherrytree")


set(CPACK_PACKAGE_NAME "cherrytree")
set(CPACK_PACKAGE_CONTACT "Giuseppe Penone <giuspen@gmail.com>")
set(CPACK_PACKAGE_VENDOR ${CPACK_PACKAGE_CONTACT})
set(CPACK_PACKAGE_VERSION ${CT_VERSION})
set(CPACK_PACKAGE_DESCRIPTION_FILE "${CMAKE_CURRENT_SOURCE_DIR}/README.md")
set(CPACK_PACKAGE_DESCRIPTION_SUMMARY "A Hierarchical Note Taking Application, featuring Rich Text and Syntax Highlighting.")
set(CPACK_RESOURCE_FILE_LICENSE "${CMAKE_CURRENT_SOURCE_DIR}/../license.txt")
set(CPACK_PACKAGING_INSTALL_PREFIX ${CMAKE_INSTALL_PREFIX})
set(CPACK_PACKAGE_CHECKSUM "SHA256")
set(CPACK_PACKAGE_EXECUTABLES ${CPACK_PACKAGE_CONTACT})
set(CPACK_CREATE_DESKTOP_LINKS ${CPACK_PACKAGE_CONTACT})
set(CPACK_PACKAGE_INSTALL_DIRECTORY ${CPACK_PACKAGE_CONTACT})
set(CPACK_STRIP_FILES TRUE)

set(CPACK_DEBIAN_PACKAGE_DEPENDS "libgtkmm-3.0-dev, libgtksourceviewmm-3.0-dev, libxml++2.6-dev, libsqlite3-dev, gettext, libgspell-1-dev")
set(CPACK_DEBIAN_PACKAGE_HOMEPAGE "https://www.giuspen.com/cherrytree/")
#set(CPACK_DEBIAN_PACKAGE_SECTION "graphics") which one?
set(CPACK_DEBIAN_PACKAGE_SHLIBDEPS ON)

include(CPack)


set(CMAKE_CXX_STANDARD 17)

# temporarily disable these warnings: Only <gtksourceview/gtksource.h> can be included directly.
if("${CMAKE_CXX_COMPILER_ID}" STREQUAL "GNU")
  add_compile_options(-Wno-cpp)
elseif(CMAKE_CXX_COMPILER_ID MATCHES "Clang")
  add_compile_options("-Wno-#warnings")
  add_compile_options(-Wthread-safety)
endif()


add_compile_options(-Wno-deprecated -Wno-deprecated-declarations)
if(CMAKE_BUILD_TYPE STREQUAL "")
  add_compile_options(-O3)
endif()


# Create the configuration files config.h in the root dir
configure_file(${CMAKE_SOURCE_DIR}/config.h.cmake ${CMAKE_SOURCE_DIR}/config.h)



include(FindPkgConfig)
pkg_check_modules(GTKMM gtkmm-3.0 REQUIRED)
pkg_check_modules(GTKSVMM gtksourceviewmm-3.0 REQUIRED)
pkg_check_modules(GLIBMM glibmm-2.4 REQUIRED)
pkg_check_modules(PANGOMM pangomm-1.4 REQUIRED)
pkg_check_modules(GSPELL gspell-1 REQUIRED)
pkg_check_modules(LIBXML libxml++-2.6 REQUIRED)
pkg_check_modules(SQLITE sqlite3 REQUIRED)
pkg_check_modules(CPPUTEST cpputest  REQUIRED)

add_subdirectory(src/7za)


include(FindPackageHandleStandardArgs)

# For both src and tests targets
include_directories(
  SYSTEM ${GTKMM_INCLUDE_DIRS}
  SYSTEM ${GTKSVMM_INCLUDE_DIRS}
  SYSTEM ${GLIBMM_INCLUDE_DIRS}
  SYSTEM ${PANGOMM_INCLUDE_DIRS}
  SYSTEM ${GSPELL_INCLUDE_DIRS}
  SYSTEM ${LIBXML_INCLUDE_DIRS}
  SYSTEM ${SQLITE_INCLUDE_DIRS}
  include_directories(.) # to find src/fmt
)

add_subdirectory(src/ct)

enable_testing()
add_subdirectory(tests)



# rebuild man pages
set(MANFILE_FULL "${CMAKE_SOURCE_DIR}/data/cherrytree.1")
set(MANFILE_FULL_GZ "${MANFILE_FULL}.gz")
add_custom_command(
        OUTPUT ${MANFILE_FULL_GZ}
	COMMAND gzip -f -k --best -n "${MANFILE_FULL}"
)
add_custom_target(man_pages ALL DEPENDS ${MANFILE_FULL_GZ})

# install commands
install(TARGETS cherrytree RUNTIME DESTINATION bin)
if(${CMAKE_SYSTEM_NAME} MATCHES Linux|.*BSD|DragonFly)
  # share data
  install(FILES "${CMAKE_SOURCE_DIR}/data/cherrytree.desktop"
          DESTINATION "${SHARE_INSTALL}/applications")
  install(FILES "${CMAKE_SOURCE_DIR}/icons/cherrytree.svg"
          DESTINATION "${SHARE_INSTALL}/icons/hicolor/scalable/apps")
  install(FILES "${MANFILE_FULL_GZ}"
          DESTINATION "${SHARE_INSTALL}/man/man1")
  install(FILES 
          "${CMAKE_SOURCE_DIR}/data/cherrytree.mime"
          "${CMAKE_SOURCE_DIR}/data/cherrytree.keys"
          DESTINATION "${SHARE_INSTALL}/mime-info")
  install(FILES "${CMAKE_SOURCE_DIR}/data/cherrytree.appdata.xml"
          DESTINATION "${SHARE_INSTALL}/metainfo")

  # share/cherrytree data
  install(FILES 
          "${CMAKE_SOURCE_DIR}/language-specs/clisp.lang"
          "${CMAKE_SOURCE_DIR}/language-specs/markdown-extra.lang"
          DESTINATION "${CHERRYTREE_SHARE_INSTALL}/language-specs")
  install(FILES 
          "${CMAKE_SOURCE_DIR}/data/script3.js"
          "${CMAKE_SOURCE_DIR}/data/styles3.css"
          DESTINATION "${CHERRYTREE_SHARE_INSTALL}/data")
endif()

=== future/tests/CMakeLists.txt ===

include_directories(
    ${CPPUTEST_INCLUDE_DIRS}
    ${CMAKE_SOURCE_DIR}/src/ct
)

set(CT_TEST_FILES
    tests_misc_utils.cpp
    tests_tmp_n_p7zip.cpp
    tests_types.cpp
)

add_executable(run_tests ${CT_TEST_FILES})
target_link_libraries(run_tests 
    ${CPPUTEST_LIBRARIES}
    cherrytree_shared
)

set_target_properties(run_tests PROPERTIES RUNTIME_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}")

add_test(run_tests run_tests)

=== future/src/ct/CMakeLists.txt ===

add_compile_options(-Wall -Wextra -Wunreachable-code -Wuninitialized)

# Generating icons
execute_process(
    COMMAND python3 ${CMAKE_SOURCE_DIR}/scripts/gresource_to_c.py
    WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
)

set(CT_SHARED_FILES
    ct_actions_edit.cc
    ct_actions_export.cc
    ct_actions_file.cc
    ct_actions_find.cc
    ct_actions_format.cc
    ct_actions_others.cc
    ct_actions_tree.cc
    ct_actions_view.cc
    ct_app.cc
    ct_clipboard.cc
    ct_codebox.cc
    ct_config.cc
    ct_dialogs.cc
    ct_export2html.cc
    ct_export2pdf.cc
    ct_export2txt.cc
    ct_image.cc
    ct_imports.cc
    ct_list.cc
    ct_main_win.cc
    ct_menu.cc
    ct_misc_utils.cc
    ct_p7za_iface.cc
    ct_pref_dlg.cc
    ct_state_machine.cc
    ct_storage_control.cc
    ct_storage_sqlite.cc
    ct_storage_xml.cc
    ct_table.cc
    ct_treestore.cc
    ct_widgets.cc
)

add_library(cherrytree_shared STATIC ${CT_SHARED_FILES})
target_link_libraries(cherrytree_shared
    ${GTKMM_LIBRARIES}
    ${GTKSVMM_LIBRARIES}
    ${GLIBMM_LIBRARIES}
    ${PANGOMM_LIBRARIES}
    ${GSPELL_LIBRARIES}
    ${LIBXML_LIBRARIES}
    ${SQLITE_LIBRARIES}
    pthread
    7za_static
)

add_executable(cherrytree ct_main.cc icons.gresource.cc)
target_link_libraries(cherrytree cherrytree_shared)

set_target_properties(cherrytree PROPERTIES RUNTIME_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}")

## cherrytree 0.23.1

=== debian/changelog ===
cherrytree (0.23.1-1) unstable; urgency=low

  * Initial release. (Closes: #580358)

 -- Vincent Cheng <Vincentc1208@gmail.com>  Fri, 14 Oct 2011 00:51:59 -0700

=== debian/control ===
Source: cherrytree
Section: editors
Priority: optional
Maintainer: Vincent Cheng <Vincentc1208@gmail.com>
Build-Depends: debhelper (>= 8), python (>= 2.6.6-3~), gettext,
 desktop-file-utils
X-Python-Version: >= 2.6
Standards-Version: 3.9.2
Homepage: http://www.giuspen.com/cherrytree/
Vcs-Svn: svn://svn.debian.org/svn/collab-maint/deb-maint/cherrytree/trunk
Vcs-Browser: http://svn.debian.org/wsvn/collab-maint/deb-maint/cherrytree/trunk

Package: cherrytree
Architecture: all
Depends: ${python:Depends}, ${misc:Depends}, python-gtk2,
 python-gtksourceview2, p7zip-full
Description: hierarchical note taking application
 CherryTree is a hierarchical note taking application, featuring rich text,
 syntax highlighting, images handling, hyperlinks, import/export with support
 for multiple formats, support for multiple languages, and more.

=== debian/watch ===
version=3
http://www.giuspen.com/software/cherrytree-(.*)\.tar\.gz

## cherrytree 0.25

=== debian/changelog ===
cherrytree (0.25-1) unstable; urgency=low

  * New upstream release.

 -- Vincent Cheng <Vincentc1208@gmail.com>  Sat, 14 Jan 2012 16:55:58 -0800

cherrytree (0.24-1) unstable; urgency=low

  * New upstream release.

 -- Vincent Cheng <Vincentc1208@gmail.com>  Wed, 28 Dec 2011 17:31:08 -0800

## cherrytree 0.25.3

=== debian/changelog ===
cherrytree (0.25.3-1) unstable; urgency=low

  * New upstream release.

 -- Vincent Cheng <Vincentc1208@gmail.com>  Fri, 10 Feb 2012 16:12:38 -0800

## cherrytree 0.25.4

=== debian/changelog ===
cherrytree (0.25.4-1) unstable; urgency=low

  * New upstream release.
  * Add versioned dependency on python-gtk2 (>= 2.16).
  * Update Format header in debian/copyright to latest DEP-5 revision.
  * Bump standards version to 3.9.3, no changes required.
  * Bump dh compat level to 9.

 -- Vincent Cheng <Vincentc1208@gmail.com>  Thu, 03 May 2012 22:53:41 -0700

=== debian/control ===
Source: cherrytree
Section: editors
Priority: optional
Maintainer: Vincent Cheng <Vincentc1208@gmail.com>
Build-Depends:
 debhelper (>= 9),
 desktop-file-utils,
 gettext,
 python (>= 2.6.6-3~)
X-Python-Version: >= 2.6
Standards-Version: 3.9.3
Homepage: http://www.giuspen.com/cherrytree/
Vcs-Svn: svn://svn.debian.org/svn/collab-maint/deb-maint/cherrytree/trunk
Vcs-Browser: http://svn.debian.org/wsvn/collab-maint/deb-maint/cherrytree/trunk

Package: cherrytree
Architecture: all
Depends:
 p7zip-full,
 python-gtk2 (>= 2.16),
 python-gtksourceview2,
 ${misc:Depends},
 ${python:Depends}
Description: hierarchical note taking application
 CherryTree is a hierarchical note taking application, featuring rich text,
 syntax highlighting, images handling, hyperlinks, import/export with support
 for multiple formats, support for multiple languages, and more.

## cherrytree 0.28

=== debian/changelog ===
cherrytree (0.28-1) unstable; urgency=low

  * New upstream release.
  * Bump standards version to 3.9.4, no changes required.

 -- Vincent Cheng <Vincentc1208@gmail.com>  Sat, 13 Oct 2012 18:54:17 -0700

cherrytree (0.27.1-1) unstable; urgency=low

  * New upstream release.

 -- Vincent Cheng <Vincentc1208@gmail.com>  Mon, 01 Oct 2012 22:29:16 -0700

cherrytree (0.27-1) unstable; urgency=low

  * New upstream release.

 -- Vincent Cheng <Vincentc1208@gmail.com>  Tue, 18 Sep 2012 22:10:03 -0700

cherrytree (0.26.3-1) unstable; urgency=low

  * New upstream release.
  * Update debian/watch file to look for .bz2/.xz tarballs.

 -- Vincent Cheng <Vincentc1208@gmail.com>  Sat, 25 Aug 2012 20:22:50 -0700

## cherrytree 0.28.5

=== debian/changelog ===
cherrytree (0.28.5-1) unstable; urgency=low

  * New upstream release.

 -- Vincent Cheng <Vincentc1208@gmail.com>  Tue, 20 Nov 2012 16:52:01 -0800

cherrytree (0.28.4-1) unstable; urgency=low

  * New upstream release.

 -- Vincent Cheng <Vincentc1208@gmail.com>  Sun, 11 Nov 2012 17:06:44 -0800

=== debian/control ===
--- 
+++ 
@@ -8,7 +8,7 @@
  gettext,
  python (>= 2.6.6-3~)
 X-Python-Version: >= 2.6
-Standards-Version: 3.9.3
+Standards-Version: 3.9.4
 Homepage: http://www.giuspen.com/cherrytree/
 Vcs-Svn: svn://svn.debian.org/svn/collab-maint/deb-maint/cherrytree/trunk
 Vcs-Browser: http://svn.debian.org/wsvn/collab-maint/deb-maint/cherrytree/trunk

## cherrytree 0.29

=== debian/changelog ===
cherrytree (0.29-1) unstable; urgency=low

  * New upstream release.
  * Fix lintian tag vcs-field-not-canonical.

 -- Vincent Cheng <Vincentc1208@gmail.com>  Thu, 10 Jan 2013 21:42:21 -0800

## cherrytree 0.29.2

=== debian/changelog ===
cherrytree (0.29.2-1) unstable; urgency=low

  * New upstream release.

 -- Vincent Cheng <Vincentc1208@gmail.com>  Wed, 30 Jan 2013 21:43:46 -0800

=== debian/control ===
--- 
+++ 
@@ -10,8 +10,8 @@
 X-Python-Version: >= 2.6
 Standards-Version: 3.9.4
 Homepage: http://www.giuspen.com/cherrytree/
-Vcs-Svn: svn://svn.debian.org/svn/collab-maint/deb-maint/cherrytree/trunk
-Vcs-Browser: http://svn.debian.org/wsvn/collab-maint/deb-maint/cherrytree/trunk
+Vcs-Svn: svn://anonscm.debian.org/collab-maint/deb-maint/cherrytree/trunk
+Vcs-Browser: http://anonscm.debian.org/viewvc/collab-maint/deb-maint/cherrytree/trunk
 
 Package: cherrytree
 Architecture: all

## cherrytree 0.29.4

=== debian/changelog ===
cherrytree (0.29.4-1) unstable; urgency=low

  * New upstream release.

 -- Vincent Cheng <Vincentc1208@gmail.com>  Thu, 21 Mar 2013 21:42:14 -0700

cherrytree (0.29.3-1) unstable; urgency=low

  * New upstream release.

 -- Vincent Cheng <Vincentc1208@gmail.com>  Wed, 13 Mar 2013 18:42:59 -0700

## cherrytree 0.30.5

=== debian/changelog ===
cherrytree (0.30.5-1) unstable; urgency=low

  * New upstream release.

 -- Vincent Cheng <Vincentc1208@gmail.com>  Sat, 31 Aug 2013 03:00:39 -0700

cherrytree (0.30.2-1) unstable; urgency=low

  * New upstream release.
  * Add dependency on python-enchant.
  * Update debian/copyright since cherrytree is now GPL-3+.

 -- Vincent Cheng <Vincentc1208@gmail.com>  Wed, 28 Aug 2013 01:49:29 -0700

cherrytree (0.30.1-1) unstable; urgency=low

  * New upstream release.

 -- Vincent Cheng <Vincentc1208@gmail.com>  Sat, 24 Aug 2013 03:10:17 -0700

=== debian/control ===
--- 
+++ 
@@ -17,6 +17,7 @@
 Architecture: all
 Depends:
  p7zip-full,
+ python-enchant,
  python-gtk2 (>= 2.16),
  python-gtksourceview2,
  ${misc:Depends},

## cherrytree 0.31.5

=== debian/changelog ===
cherrytree (0.31.5-1) unstable; urgency=medium

  * New upstream release.
  * Add dependency on python-appindicator.
  * Bump standards version to 3.9.5, no changes required.

 -- Vincent Cheng <Vincentc1208@gmail.com>  Fri, 20 Dec 2013 15:47:17 -0800

## cherrytree 0.32.0

=== debian/changelog ===
cherrytree (0.32.0-1) unstable; urgency=medium

  * New upstream release.

 -- Vincent Cheng <Vincentc1208@gmail.com>  Sun, 05 Jan 2014 01:13:32 -0800

=== debian/control ===
--- 
+++ 
@@ -8,7 +8,7 @@
  gettext,
  python (>= 2.6.6-3~)
 X-Python-Version: >= 2.6
-Standards-Version: 3.9.4
+Standards-Version: 3.9.5
 Homepage: http://www.giuspen.com/cherrytree/
 Vcs-Svn: svn://anonscm.debian.org/collab-maint/deb-maint/cherrytree/trunk
 Vcs-Browser: http://anonscm.debian.org/viewvc/collab-maint/deb-maint/cherrytree/trunk
@@ -17,6 +17,7 @@
 Architecture: all
 Depends:
  p7zip-full,
+ python-appindicator,
  python-enchant,
  python-gtk2 (>= 2.16),
  python-gtksourceview2,

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@ --with python2

override_dh_clean:
	rm -rf build/
	dh_clean

=== debian/watch ===
version=3
http://www.giuspen.com/software/cherrytree-(.*)\.tar\.(?:gz|bz2|xz)

## cherrytree 0.34.0

=== debian/changelog ===
cherrytree (0.34.0-1) unstable; urgency=medium

  * New upstream release.

 -- Vincent Cheng <vcheng@debian.org>  Wed, 06 Aug 2014 23:47:49 -0700

cherrytree (0.33.4-1) unstable; urgency=medium

  * New upstream release.

 -- Vincent Cheng <vcheng@debian.org>  Sat, 31 May 2014 13:05:51 -0700

cherrytree (0.33.3-1) unstable; urgency=medium

  * New upstream release.

 -- Vincent Cheng <vcheng@debian.org>  Sun, 25 May 2014 01:10:44 -0700

cherrytree (0.33.1-1) unstable; urgency=medium

  * New upstream release.
  * Add dependency on python-dbus.

 -- Vincent Cheng <vcheng@debian.org>  Sun, 11 May 2014 20:40:06 -0700

cherrytree (0.33.0-1) unstable; urgency=medium

  * New upstream release.
  * Update email address.

 -- Vincent Cheng <vcheng@debian.org>  Sat, 26 Apr 2014 15:19:12 -0700

## cherrytree 0.34.1

=== debian/changelog ===
cherrytree (0.34.1-1) unstable; urgency=medium

  * New upstream release.

 -- Vincent Cheng <vcheng@debian.org>  Sat, 16 Aug 2014 23:37:12 -0700

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,7 @@
 Source: cherrytree
 Section: editors
 Priority: optional
-Maintainer: Vincent Cheng <Vincentc1208@gmail.com>
+Maintainer: Vincent Cheng <vcheng@debian.org>
 Build-Depends:
  debhelper (>= 9),
  desktop-file-utils,
@@ -18,6 +18,7 @@
 Depends:
  p7zip-full,
  python-appindicator,
+ python-dbus,
  python-enchant,
  python-gtk2 (>= 2.16),
  python-gtksourceview2,

## cherrytree 0.35.2

=== debian/changelog ===
cherrytree (0.35.2-1) unstable; urgency=medium

  * New upstream release.
  * Move maintainership of package to the Python Applications Packaging Team
    <python-apps-team@lists.alioth.debian.org>.
    - Add myself to Uploaders.
  * Bump standards version to 3.9.6, no changes required.

 -- Vincent Cheng <vcheng@debian.org>  Wed, 15 Oct 2014 23:50:58 -0700

## cherrytree 0.35.5

=== debian/changelog ===
cherrytree (0.35.5-1) unstable; urgency=medium

  * New upstream release.

 -- Vincent Cheng <vcheng@debian.org>  Fri, 05 Dec 2014 00:00:16 -0800

cherrytree (0.35.4-1) unstable; urgency=medium

  * New upstream release.

 -- Vincent Cheng <vcheng@debian.org>  Mon, 10 Nov 2014 00:31:31 -0800

cherrytree (0.35.3-1) unstable; urgency=medium

  * New upstream release.

 -- Vincent Cheng <vcheng@debian.org>  Wed, 05 Nov 2014 23:34:38 -0800

## cherrytree 0.35.6

=== debian/changelog ===
cherrytree (0.35.6-1) unstable; urgency=medium

  * New upstream release.

 -- Vincent Cheng <vcheng@debian.org>  Mon, 29 Dec 2014 17:04:42 -0800

## cherrytree 0.35.7

=== debian/changelog ===
cherrytree (0.35.7-1) unstable; urgency=medium

  * New upstream release.

 -- Vincent Cheng <vcheng@debian.org>  Tue, 03 Feb 2015 01:18:43 -0800

## cherrytree 0.35.8

=== debian/changelog ===
cherrytree (0.35.8-1) unstable; urgency=medium

  * New upstream release.

 -- Vincent Cheng <vcheng@debian.org>  Mon, 01 Jun 2015 02:42:00 -0700

## cherrytree 0.35.9

=== debian/changelog ===
cherrytree (0.35.9-1) unstable; urgency=medium

  * New upstream release.

 -- Vincent Cheng <vcheng@debian.org>  Mon, 06 Jul 2015 23:38:38 -0700

=== debian/control ===
--- 
+++ 
@@ -1,17 +1,18 @@
 Source: cherrytree
 Section: editors
 Priority: optional
-Maintainer: Vincent Cheng <vcheng@debian.org>
+Maintainer: Python Applications Packaging Team <python-apps-team@lists.alioth.debian.org>
+Uploaders: Vincent Cheng <vcheng@debian.org>
 Build-Depends:
  debhelper (>= 9),
  desktop-file-utils,
  gettext,
  python (>= 2.6.6-3~)
 X-Python-Version: >= 2.6
-Standards-Version: 3.9.5
+Standards-Version: 3.9.6
 Homepage: http://www.giuspen.com/cherrytree/
-Vcs-Svn: svn://anonscm.debian.org/collab-maint/deb-maint/cherrytree/trunk
-Vcs-Browser: http://anonscm.debian.org/viewvc/collab-maint/deb-maint/cherrytree/trunk
+Vcs-Svn: svn://anonscm.debian.org/python-apps/packages/cherrytree/trunk/
+Vcs-Browser: http://anonscm.debian.org/viewvc/python-apps/packages/cherrytree/trunk/
 
 Package: cherrytree
 Architecture: all

## cherrytree 0.35.10

=== debian/changelog ===
cherrytree (0.35.10-1) unstable; urgency=medium

  * New upstream release.

 -- Vincent Cheng <vcheng@debian.org>  Mon, 17 Aug 2015 23:15:51 -0700

## cherrytree 0.35.11

=== debian/changelog ===
cherrytree (0.35.11-1) unstable; urgency=medium

  * New upstream release.
  * Add build-dep on dh-python.
  * Drop Debian menu file as per tech-ctte decision.

 -- Vincent Cheng <vcheng@debian.org>  Thu, 08 Oct 2015 23:10:39 -0700

=== debian/control ===
--- 
+++ 
@@ -6,6 +6,7 @@
 Build-Depends:
  debhelper (>= 9),
  desktop-file-utils,
+ dh-python,
  gettext,
  python (>= 2.6.6-3~)
 X-Python-Version: >= 2.6

## cherrytree 0.36.2

=== debian/changelog ===
cherrytree (0.36.2-1) unstable; urgency=medium

  * New upstream release.

 -- Vincent Cheng <vcheng@debian.org>  Sun, 20 Dec 2015 22:59:16 -0800

## cherrytree 0.36.3

=== debian/changelog ===
cherrytree (0.36.3-1) unstable; urgency=medium

  * New upstream release.

 -- Vincent Cheng <vcheng@debian.org>  Wed, 23 Dec 2015 22:26:54 -0800

## cherrytree 0.36.4

=== debian/changelog ===
cherrytree (0.36.4-1) unstable; urgency=medium

  * New upstream release.

 -- Vincent Cheng <vcheng@debian.org>  Tue, 26 Jan 2016 21:35:31 -0800

=== debian/control ===
--- 
+++ 
@@ -13,7 +13,7 @@
 Standards-Version: 3.9.6
 Homepage: http://www.giuspen.com/cherrytree/
 Vcs-Svn: svn://anonscm.debian.org/python-apps/packages/cherrytree/trunk/
-Vcs-Browser: http://anonscm.debian.org/viewvc/python-apps/packages/cherrytree/trunk/
+Vcs-Browser: https://anonscm.debian.org/viewvc/python-apps/packages/cherrytree/trunk/
 
 Package: cherrytree
 Architecture: all

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@ --with python2 --buildsystem=pybuild

override_dh_clean:
	rm -rf build/
	dh_clean

## cherrytree 0.36.9

=== debian/changelog ===
cherrytree (0.36.9-1) unstable; urgency=medium

  * New upstream release.
  * Bump standards version to 3.9.7, no changes required.
  * Update watch file.

 -- Vincent Cheng <vcheng@debian.org>  Wed, 06 Apr 2016 20:01:32 -0700

=== debian/control ===
--- 
+++ 
@@ -10,7 +10,7 @@
  gettext,
  python (>= 2.6.6-3~)
 X-Python-Version: >= 2.6
-Standards-Version: 3.9.6
+Standards-Version: 3.9.7
 Homepage: http://www.giuspen.com/cherrytree/
 Vcs-Svn: svn://anonscm.debian.org/python-apps/packages/cherrytree/trunk/
 Vcs-Browser: https://anonscm.debian.org/viewvc/python-apps/packages/cherrytree/trunk/

=== debian/watch ===
version=3
http://www.giuspen.com/cherrytree/ http://www.giuspen.com/software/cherrytree-(.*)\.tar\.(?:gz|bz2|xz)

## cherrytree 0.37.0

=== debian/changelog ===
cherrytree (0.37.0-1) unstable; urgency=medium

  * New upstream release.
  * Bump standards version to 3.9.8, no changes required.

 -- Vincent Cheng <vcheng@debian.org>  Fri, 27 May 2016 01:51:05 -0700

=== debian/control ===
--- 
+++ 
@@ -10,7 +10,7 @@
  gettext,
  python (>= 2.6.6-3~)
 X-Python-Version: >= 2.6
-Standards-Version: 3.9.7
+Standards-Version: 3.9.8
 Homepage: http://www.giuspen.com/cherrytree/
 Vcs-Svn: svn://anonscm.debian.org/python-apps/packages/cherrytree/trunk/
 Vcs-Browser: https://anonscm.debian.org/viewvc/python-apps/packages/cherrytree/trunk/

## cherrytree 0.37.1

=== debian/changelog ===
cherrytree (0.37.1-1) unstable; urgency=medium

  * New upstream release.

 -- Vincent Cheng <vcheng@debian.org>  Sun, 19 Jun 2016 22:42:29 -0700

## cherrytree 0.37.2

=== debian/changelog ===
cherrytree (0.37.2-1) unstable; urgency=medium

  * New upstream release.

 -- Vincent Cheng <vcheng@debian.org>  Sun, 10 Jul 2016 20:54:39 -0700

## cherrytree 0.37.6

=== debian/changelog ===
cherrytree (0.37.6-1) unstable; urgency=medium

  * New upstream release.

 -- Vincent Cheng <vcheng@debian.org>  Mon, 24 Oct 2016 21:48:13 -0700

cherrytree (0.37.5-1) unstable; urgency=medium

  * New upstream release.

 -- Vincent Cheng <vcheng@debian.org>  Sun, 02 Oct 2016 18:26:04 -0700

cherrytree (0.37.4-1) unstable; urgency=medium

  * New upstream release.

 -- Vincent Cheng <vcheng@debian.org>  Thu, 01 Sep 2016 23:19:07 -0700

=== debian/control ===
--- 
+++ 
@@ -22,6 +22,7 @@
  python-appindicator,
  python-dbus,
  python-enchant,
+ python-chardet,
  python-gtk2 (>= 2.16),
  python-gtksourceview2,
  ${misc:Depends},

## cherrytree 0.38.5

=== debian/changelog ===
cherrytree (0.38.5-0.1~mx17+1) mx; urgency=medium

  * Rebuild for MX 17.
  * Revert to debhelper compat 9 to ease backports.

 -- Steven Pusser <stevep@mxlinux.org>  Fri, 24 Aug 2018 10:54:17 -0700

cherrytree (0.38.5-0kali1) kali-dev; urgency=medium

  * Import new upstream release
  * Remove dependency on python-appindicator: package removed from Debian and
    it's not required for Kali

 -- Sophie Brun <sophie@freexian.com>  Fri, 13 Jul 2018 10:32:28 +0200

cherrytree (0.38.4-0kali1) kali-dev; urgency=medium

  * Import new upstream release

 -- Sophie Brun <sophie@freexian.com>  Mon, 09 Apr 2018 12:14:16 +0200

cherrytree (0.38.2-0kali1) kali-dev; urgency=medium

  * Initial release (Closes: 4269)

 -- Sophie Brun <sophie@freexian.com>  Tue, 10 Oct 2017 15:58:51 +0200

=== debian/control ===
Source: cherrytree
Section: editors
Priority: optional
Maintainer: Steven Pusser <stevep@mxlinux.org>
XSBC-Original-Maintainer: Kali Developers <devel@kali.org>
Uploaders: Sophie Brun <sophie@freexian.com>
Build-Depends: debhelper (>= 9), dh-python, python-all, python-setuptools
Standards-Version: 4.1.5
Homepage: http://www.giuspen.com/cherrytree
Vcs-Git: git://git.kali.org/packages/cherrytree.git
Vcs-Browser: http://git.kali.org/gitweb/?p=packages/cherrytree.git;a=summary

Package: cherrytree
Architecture: all
Depends: ${python:Depends},
         ${misc:Depends},
         p7zip-full,
         python-chardet,
         python-dbus,
         python-enchant,
         python-gtk2 (>= 2.16),
         python-gtksourceview2
Description: hierarchical note taking application
 This package contains a hierarchical note taking application, featuring rich
 text and syntax highlighting, images handling, hyperlinks, import/export with
 support for multiple formats, support for multiple languages, and more.

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE = 1

export PYBUILD_NAME=cherrytree

%:
	dh $@ --with python2 --buildsystem=pybuild

=== debian/tests/control ===
Test-Command: cherrytree -h

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%cherrytree-$1.tar.gz%" \
   https://github.com/giuspen/cherrytree/tags \
   (?:.*?/)?v?(\d[\d.]*)\.tar\.gz debian uupdate

## cherrytree 0.38.7

=== debian/changelog ===
cherrytree (0.38.7-0.1~mx17+1) mx; urgency=medium

  * New upstream release.

 -- Steven Pusser <stevep@mxlinux.org>  Wed, 02 Jan 2019 12:24:45 -0800

cherrytree (0.38.6-0.1~mx17+1) mx; urgency=medium

  * New upstream release:
    - bugfix – do not throw error when failing to clean temporary
      directory (#392).
    - bugfix – workaround for locale.get issues (#395).
    - bugfix – import from html of table error resulting in paste from clipboard
      error (#236).
    - bugfix – multilevel numbered lists not restarting from one.
    - bugfix – wrap line with a single very long word (#378).
    - todo list characters configurable in config.cfg (#339).
    - import from zim, support for codebox (#386).

 -- Steven Pusser <stevep@mxlinux.org>  Wed, 31 Oct 2018 17:49:36 -0700

=== debian/control ===
Source: cherrytree
Section: editors
Priority: optional
Maintainer: Steven Pusser <stevep@mxlinux.org>
XSBC-Original-Maintainer: Giuseppe Penone <giuspen@gmail.com>
Build-Depends:
 debhelper (>= 9),
 desktop-file-utils,
 dh-python,
 gettext,
 python (>= 2.6.6-3~)
X-Python-Version: >= 2.6
Standards-Version: 3.9.5
Homepage: http://www.giuspen.com/cherrytree/
Vcs-Git: https://github.com/giuspen/cherrytree.git
Vcs-Browser: https://github.com/giuspen/cherrytree

Package: cherrytree
Architecture: all
Depends:
 p7zip-full,
 python-dbus,
 python-enchant,
 python-chardet,
 python-gtk2 (>= 2.16),
 python-gtksourceview2,
 ${misc:Depends}
Recommends:
 python-appindicator
Description: hierarchical note taking application
 CherryTree is a hierarchical note taking application, featuring rich text,
 syntax highlighting, images handling, hyperlinks, import/export with support
 for multiple formats, support for multiple languages, and more.

## cherrytree 0.38.8

=== debian/changelog ===
cherrytree (0.38.8-0.1~mx17+1) mx; urgency=medium

  * New upstream release:
    - Improved implementation of deletion of recent documents entry.
    - Ctrl+Space to toggle To-Do List Item State.
    - Fix detection of missing installation of xterm required in code execution
      on Linux (with default settings).
    - Horizontal rule insert without hard coded newline before
      (still newline after).
    - updated Spanish language (Daniel).
    - updated Greek language (Delphina).
    - updated Armenian language (Seda).

 -- Steven Pusser <stevep@mxlinux.org>  Thu, 28 Feb 2019 15:51:36 -0800

## cherrytree 0.38.9

=== debian/changelog ===
cherrytree (0.38.9-0.1~mx19+1) mx; urgency=medium

  * Initial packaging for MX-1
  * Removed default debian folder and redebianized
  * New upstream release

 -- ”SwampRabbit” <maintainer@mepiscommunity.org>  Wed, 04 Dec 2019 10:27:04 -0500

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@ --buildsystem=pybuild

override_dh_clean:
	rm -rf build/
	dh_clean

override_dh_shlibdeps:
	dh_shlibdeps -- -xvirtualbox-guest-x11 --ignore-missing-info

## cherrytree 0.38.11

=== debian/changelog ===
cherrytree (0.38.11-0~mx19+1) mx; urgency=medium

  * Package new upstream release for MX 19.
  * Fixed regression of 0.38.10, could no longer print

 -- ”SwampRabbit” <maintainer@mepiscommunity.org>  Sun, 26 Jan 2020 15:02:44 -0500

=== debian/control ===
Source: cherrytree
Section: editors
Priority: optional
Maintainer: SwampRabbit <maintainer@mepiscommunity.org>
XSBC-Original-Maintainer: Giuseppe Penone <giuspen@gmail.com>
Build-Depends:
 debhelper (>= 9),
 desktop-file-utils,
 dh-python,
 gettext,
 python (>= 2.6.6-3~),
 python-setuptools
X-Python-Version: >= 2.6
Standards-Version: 3.9.5
Homepage: http://www.giuspen.com/cherrytree/
Vcs-Git: https://github.com/giuspen/cherrytree.git
Vcs-Browser: https://github.com/giuspen/cherrytree

Package: cherrytree
Architecture: all
Depends:
 ${python:Depends},
 ${misc:Depends},
 p7zip-full,
 python-dbus,
 python-enchant,
 python-chardet,
 python-gtk2 (>= 2.16),
 python-gtksourceview2
Description: hierarchical note taking application
 CherryTree is a hierarchical note taking application, featuring rich text,
 syntax highlighting, images handling, hyperlinks, import/export with support
 for multiple formats, support for multiple languages, and more.

## cherrytree 0.39.0

=== debian/changelog ===
cherrytree (0.39.0-0~mx19+1) mx; urgency=medium

  * Initial packaging of new upstream release for MX 19.

 -- ”SwampRabbit” <maintainer@mepiscommunity.org>  Tue, 17 Mar 2020 22:00:18 -0400

cherrytree (0.39.0-0) bionic; urgency=low

  * improved export to html (work of @ksmukta)
  * fixed export to pdf, picture blurry (work of @txe)
  * implemented a 'command palette' dialog to quickly access all the commands in one place (work of @ksmukta)
  * improved sorting (work of @txe)
  * improved performance of imports into cherrytre (work of @txe)
  * fixed 'recent document paths have wrong enconding' (#632, work of @txe)
  * fixed 'files with russian names won't open through command line under Windows' (#633, work of @txe)
  * fixed 'visited nodes history, going to todays node using key binding' (work of @ksmukta)
  * fixed 'syntax Highlighting selected first from list when pressing enter' (#657, work of @txe)
  * updated syntax highlighting language specs files for various languages (#228, #92, #38, work of @txe)
  * cursor to stay inside codeBox after creation (#655, work of @txe - remember: Ctrl+Space moves the cursor in and out the codebox)
  * added triple click functionality to select paragraph (work of @letto4135)
  * fixed smart quotes spell check bug (work of @letto4135)
  * added new language Swedish (translated by Åke Engelbrektson)
  * note that cherrytree is now available also as a snap package (created and maintained by Heather Ellsworth, https://snapcraft.io/cherrytree)


 -- Giuseppe Penone <giuspen@gmail.com>  Wed, 04 Mar 2020 07:27:27 +0000

=== debian/control ===
--- 
+++ 
@@ -8,8 +8,7 @@
  desktop-file-utils,
  dh-python,
  gettext,
- python (>= 2.6.6-3~),
- python-setuptools
+ python (>= 2.6.6-3~)
 X-Python-Version: >= 2.6
 Standards-Version: 3.9.5
 Homepage: http://www.giuspen.com/cherrytree/
@@ -19,14 +18,15 @@
 Package: cherrytree
 Architecture: all
 Depends:
- ${python:Depends},
- ${misc:Depends},
  p7zip-full,
  python-dbus,
  python-enchant,
  python-chardet,
  python-gtk2 (>= 2.16),
- python-gtksourceview2
+ python-gtksourceview2,
+ ${misc:Depends}
+Recommends:
+ python-appindicator
 Description: hierarchical note taking application
  CherryTree is a hierarchical note taking application, featuring rich text,
  syntax highlighting, images handling, hyperlinks, import/export with support

## cherrytree 0.39.2

=== debian/changelog ===
cherrytree (0.39.2-0~mx17+1) mx; urgency=medium

  * Initial packaging of upstream release for MX 17/18.
  * Added debian/source/format 3.0 (quilt)
  * Added upstream removed Build-Depends: python-setuptools back

 -- ”SwampRabbit” <maintainer@mepiscommunity.org>  Tue, 07 Apr 2020 23:29:36 -0400

cherrytree (0.39.2-0) bionic; urgency=low

  * fix very slow node creation (#686)
  * fix Wrong "." processing in "Replace in Nodes Names" (RegExp mode) (#689)
  * workaround for dead_diaeresis, dead_acute on win32 (#427, #688)
  * fix for table's cell content lost unless you explicitly press Enter (#700)
  * fix Control/command key deselects (un-highlights) text in table (#699)
  * fix Keyboard shortcuts for sorting do not work (#305, work of @Mammoets)
  * the porting to Gtkmm3 will shortly produce the first testing version thanks to the hard work of Evgenii (@txe)


 -- Giuseppe Penone <giuspen@gmail.com>  Sat, 04 Apr 2020 15:32:32 +0100

=== debian/control ===
--- 
+++ 
@@ -8,7 +8,8 @@
  desktop-file-utils,
  dh-python,
  gettext,
- python (>= 2.6.6-3~)
+ python (>= 2.6.6-3~),
+ python-setuptools
 X-Python-Version: >= 2.6
 Standards-Version: 3.9.5
 Homepage: http://www.giuspen.com/cherrytree/

## cherrytree 0.39.3

=== debian/changelog ===
cherrytree (0.39.3-0~mx19+1) mx; urgency=medium

  * Initial packaging of upstream release for MX 19.
  * Added debian/source/format 3.0 (quilt)
  * Added upstream removed Build-Depends: python-setuptools back

 -- ”SwampRabbit” <swamprabbit@mxlinux.org>  Fri, 08 May 2020 22:46:33 -0400

cherrytree (0.39.3-0) bionic; urgency=low

  * Forbid to use '<' and '>' in password in PyGtk2 (#765) - all characters will be available in upcoming Gtkmm3 version currently under testing
  * After toggle tree visibility with tree that becomes visible, the tree gets the focus (tree gets hidden, text gets the focus)
  * Possibility to disable triple click selecting the whole paragraph, currently only editing directly config.cfg (look for triple_click_paragraph)
  * Updated language German from new maintainer Stefan Pöschel
  * Updated language Finnish (Henri Kaustinen)
  * Small fixes to Spanish translation (Roberto Vaquerizo)


 -- Giuseppe Penone <giuspen@gmail.com>  Sun, 03 May 2020 07:25:25 +0100

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,7 @@
 Source: cherrytree
 Section: editors
 Priority: optional
-Maintainer: SwampRabbit <maintainer@mepiscommunity.org>
+Maintainer: SwampRabbit <swamprabbit@mxlinux.org>
 XSBC-Original-Maintainer: Giuseppe Penone <giuspen@gmail.com>
 Build-Depends:
  debhelper (>= 9),

## cherrytree 0.39.4

=== future/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.13.2)

project(cherrytree)
set(CT_VERSION "0.99.2")


if(CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)
  set(CMAKE_INSTALL_PREFIX "/usr" CACHE PATH "..." FORCE)
endif(CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)

if(NOT PYTHON_EXEC)
  set(PYTHON_EXEC "python3")
endif(NOT PYTHON_EXEC)

option(USE_NLS "Add locales support" ON)

# used to install locale, packagers might overwrite this
if(USE_NLS)
  if(NOT PACKAGE_LOCALE_DIR)
    set(PACKAGE_LOCALE_DIR "share/locale")
  endif(NOT PACKAGE_LOCALE_DIR)
endif()

# used to install data, packagers might overwrite this
if(NOT SHARE_INSTALL)
  set(SHARE_INSTALL "share" CACHE STRING "Data file install path. Must be a relative path (from CMAKE_INSTALL_PREFIX), with no trailing slash.")
endif(NOT SHARE_INSTALL)
set(CHERRYTREE_SHARE_INSTALL "${SHARE_INSTALL}/cherrytree")


set(CPACK_PACKAGE_NAME "cherrytree")
set(CPACK_PACKAGE_CONTACT "Giuseppe Penone <giuspen@gmail.com>")
set(CPACK_PACKAGE_VENDOR ${CPACK_PACKAGE_CONTACT})
set(CPACK_PACKAGE_VERSION ${CT_VERSION})
set(CPACK_PACKAGE_DESCRIPTION_FILE "${CMAKE_CURRENT_SOURCE_DIR}/README.md")
set(CPACK_PACKAGE_DESCRIPTION_SUMMARY "A Hierarchical Note Taking Application, featuring Rich Text and Syntax Highlighting.")
set(CPACK_RESOURCE_FILE_LICENSE "${CMAKE_CURRENT_SOURCE_DIR}/../license.txt")
set(CPACK_PACKAGING_INSTALL_PREFIX ${CMAKE_INSTALL_PREFIX})
set(CPACK_PACKAGE_CHECKSUM "SHA256")
set(CPACK_PACKAGE_EXECUTABLES ${CPACK_PACKAGE_CONTACT})
set(CPACK_CREATE_DESKTOP_LINKS ${CPACK_PACKAGE_CONTACT})
set(CPACK_PACKAGE_INSTALL_DIRECTORY ${CPACK_PACKAGE_CONTACT})
set(CPACK_STRIP_FILES TRUE)

set(CPACK_DEBIAN_PACKAGE_DEPENDS "libgtkmm-3.0-1v5, libgtksourceviewmm-3.0-0v5, libxml++2.6-2v5, libsqlite3-0, libgspell-1-2, libcurl4")
set(CPACK_DEBIAN_PACKAGE_HOMEPAGE "https://www.giuspen.com/cherrytree/")
#set(CPACK_DEBIAN_PACKAGE_SECTION "graphics") which one?
set(CPACK_DEBIAN_PACKAGE_SHLIBDEPS ON)

include(CPack)


set(CMAKE_CXX_STANDARD 17)

# temporarily disable these warnings: Only <gtksourceview/gtksource.h> can be included directly.
if("${CMAKE_CXX_COMPILER_ID}" STREQUAL "GNU")
  add_compile_options(-Wno-cpp)
elseif(CMAKE_CXX_COMPILER_ID MATCHES "Clang")
  add_compile_options("-Wno-#warnings")
  add_compile_options(-Wthread-safety)
endif()


if(APPLE)
  link_directories(/usr/local/lib /usr/local/opt/gettext/lib)
  include_directories(/usr/local/opt/gettext/include)
  set(CMAKE_MACOSX_RPATH 1)
  set(ENV{PKG_CONFIG_PATH} "$ENV{PKG_CONFIG_PATH}:/usr/local/lib/pkgconfig:/opt/X11/lib/pkgconfig:/usr/local/opt/libxml2/lib/pkgconfig:/usr/local/opt/libxml++/lib/pkgconfig")
  # to fix libxml++2.6 compilation
  add_compile_options(-D_LIBCPP_ENABLE_CXX17_REMOVED_AUTO_PTR)
endif()

add_compile_options(-Wno-deprecated -Wno-deprecated-declarations)
if(CMAKE_BUILD_TYPE STREQUAL "")
  add_compile_options(-O3)
elseif (CMAKE_BUILD_TYPE STREQUAL "Debug")
  add_compile_options(-O0 -g)
endif()


# Create the configuration files config.h in the root dir
configure_file(${CMAKE_SOURCE_DIR}/config.h.cmake ${CMAKE_SOURCE_DIR}/config.h)

option(BUILD_TESTING "Build tests" ON)
if (BUILD_TESTING)
  message("Tests are ON")
else()
  message("Tests are OFF")
endif()

include(FindPkgConfig)
pkg_check_modules(GTKMM gtkmm-3.0 REQUIRED)
pkg_check_modules(GTKSVMM gtksourceviewmm-3.0 REQUIRED)
pkg_check_modules(GLIBMM glibmm-2.4>=2.64 REQUIRED)
pkg_check_modules(PANGOMM pangomm-1.4 REQUIRED)
pkg_check_modules(GSPELL gspell-1 REQUIRED)
pkg_check_modules(LIBXML libxml++-2.6 REQUIRED)
pkg_check_modules(SQLITE sqlite3 REQUIRED)
pkg_check_modules(CURL libcurl REQUIRED)
if(BUILD_TESTING)
  pkg_check_modules(CPPUTEST cpputest  REQUIRED)
endif()

add_subdirectory(src/7za)

# Spdlog
add_subdirectory(src/spdlog)


include(FindPackageHandleStandardArgs)

# For both src and tests targets
include_directories(
  SYSTEM ${GTKMM_INCLUDE_DIRS}
  SYSTEM ${GTKSVMM_INCLUDE_DIRS}
  SYSTEM ${GLIBMM_INCLUDE_DIRS}
  SYSTEM ${PANGOMM_INCLUDE_DIRS}
  SYSTEM ${GSPELL_INCLUDE_DIRS}
  SYSTEM ${LIBXML_INCLUDE_DIRS}
  SYSTEM ${SQLITE_INCLUDE_DIRS}
  SYSTEM ${CURL_INCLUDE_DIRS}
  include_directories(.) # to find src/fmt
)

add_subdirectory(src/ct)

if(BUILD_TESTING)
  enable_testing()
  add_subdirectory(tests)
endif()


# rebuild man pages
set(MANFILE_FULL "${CMAKE_SOURCE_DIR}/data/cherrytree.1")
set(MANFILE_FULL_GZ "${MANFILE_FULL}.gz")
add_custom_command(
  OUTPUT ${MANFILE_FULL_GZ}
  COMMAND gzip -f -k --best -n "${MANFILE_FULL}"
)
add_custom_target(man_pages ALL DEPENDS ${MANFILE_FULL_GZ})


# rebuild languages binaries
if(USE_NLS)
  execute_process(
    COMMAND ${PYTHON_EXEC} ${CMAKE_SOURCE_DIR}/po/i18n_po_to_mo.py
    WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
  )
endif()


# install cherrytree
install(TARGETS cherrytree RUNTIME DESTINATION bin)

# set icon on macos
if(APPLE)
  install(CODE "execute_process(COMMAND ${PYTHON_EXEC} ${CMAKE_SOURCE_DIR}/scripts/set_icon_macos.py ${CMAKE_SOURCE_DIR}/icons/cherrytree.ico ${CMAKE_INSTALL_PREFIX}/bin/cherrytree)")
endif(APPLE)

# install other files
if(${CMAKE_SYSTEM_NAME} MATCHES Linux|.*BSD|DragonFly|Darwin)
  if(NOT APPLE)
    # share data
    install(FILES "${CMAKE_SOURCE_DIR}/data/cherrytree.desktop"
            DESTINATION "${SHARE_INSTALL}/applications")
    install(FILES "${CMAKE_SOURCE_DIR}/icons/cherrytree.svg"
            DESTINATION "${SHARE_INSTALL}/icons/hicolor/scalable/apps")
    install(FILES "${MANFILE_FULL_GZ}"
            DESTINATION "${SHARE_INSTALL}/man/man1")
    install(FILES
            "${CMAKE_SOURCE_DIR}/data/cherrytree.mime"
            "${CMAKE_SOURCE_DIR}/data/cherrytree.keys"
            DESTINATION "${SHARE_INSTALL}/mime-info")
    install(FILES "${CMAKE_SOURCE_DIR}/data/com.giuspen.cherrytree.metainfo.xml"
            DESTINATION "${SHARE_INSTALL}/metainfo")
  endif(NOT APPLE)

  # share/cherrytree data
  install(DIRECTORY ${CMAKE_SOURCE_DIR}/language-specs
          DESTINATION ${CHERRYTREE_SHARE_INSTALL})
  install(FILES
          "${CMAKE_SOURCE_DIR}/data/script3.js"
          "${CMAKE_SOURCE_DIR}/data/styles3.css"
          DESTINATION "${CHERRYTREE_SHARE_INSTALL}/data")

  # locale data
  if(USE_NLS)
    file(GLOB children "${CMAKE_SOURCE_DIR}/po/*")
    foreach(child ${children})
      if(IS_DIRECTORY ${child})
        install(DIRECTORY ${child} DESTINATION "${PACKAGE_LOCALE_DIR}")
      endif()
    endforeach()
  endif()
endif()

=== future/tests/CMakeLists.txt ===

include_directories(
    ${CPPUTEST_INCLUDE_DIRS}
    ${CMAKE_SOURCE_DIR}/src/ct
)

set(CT_TEST_FILES
    tests_misc_utils.cpp
    tests_tmp_n_p7zip.cpp
    tests_types.cpp
    tests_clipboard.cpp
    tests_filesystem.cpp
    tests_encoding.cpp
)

# some tests doesn't work in TRAVIS, so turn off them
if(DEFINED ENV{TRAVIS})
    add_definitions(-D_TRAVIS)
endif()

add_executable(run_tests ${CT_TEST_FILES})
target_link_libraries(run_tests 
    ${CPPUTEST_LIBRARIES}
    cherrytree_shared
)

add_test(run_tests run_tests)

=== future/src/ct/CMakeLists.txt ===
--- 
+++ 
@@ -1,11 +1,25 @@
 
 add_compile_options(-Wall -Wextra -Wunreachable-code -Wuninitialized)
 
+if(USE_NLS)
+    add_definitions(-DHAVE_NLS)
+endif()
+
 # Generating icons
 execute_process(
-    COMMAND python3 ${CMAKE_SOURCE_DIR}/scripts/gresource_to_c.py
+    COMMAND ${PYTHON_EXEC} ${CMAKE_SOURCE_DIR}/scripts/gresource_to_c.py
     WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
 )
+
+# Generating rc file (with icon) for windows
+if(MINGW)
+    add_custom_command(OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/cherrytree_rc.o
+                       COMMAND windres.exe -I${CMAKE_SOURCE_DIR}/icons 
+                                           -i${CMAKE_SOURCE_DIR}/data/windows.rc
+                                           -o ${CMAKE_CURRENT_BINARY_DIR}/cherrytree_rc.o )
+    set(CHERRY_EXE_RC ${CMAKE_CURRENT_BINARY_DIR}/cherrytree_rc.o)
+endif(MINGW)
+
 
 set(CT_SHARED_FILES
     ct_actions_edit.cc
@@ -14,8 +28,10 @@
     ct_actions_find.cc
     ct_actions_format.cc
     ct_actions_others.cc
+    ct_actions_import.cc
     ct_actions_tree.cc
     ct_actions_view.cc
+    ct_actions_help.cc
     ct_app.cc
     ct_clipboard.cc
     ct_codebox.cc
@@ -39,7 +55,12 @@
     ct_table.cc
     ct_treestore.cc
     ct_widgets.cc
-)
+    ct_parser_text.cc
+    ct_parser_md.cc
+    ct_parser.cc
+    ct_process.cc
+    ct_filesystem.cc
+    )
 
 add_library(cherrytree_shared STATIC ${CT_SHARED_FILES})
 target_link_libraries(cherrytree_shared
@@ -50,11 +71,22 @@
     ${GSPELL_LIBRARIES}
     ${LIBXML_LIBRARIES}
     ${SQLITE_LIBRARIES}
+    ${CURL_LIBRARIES}
     pthread
     7za_static
+    spdlog::spdlog
 )
 
-add_executable(cherrytree ct_main.cc icons.gresource.cc)
+target_include_directories(cherrytree_shared PUBLIC "..")
+
+
+add_executable(cherrytree ct_main.cc icons.gresource.cc ${CHERRY_EXE_RC})
 target_link_libraries(cherrytree cherrytree_shared)
 
+if(APPLE)
+  target_link_libraries(cherrytree "-framework Foundation -framework AppKit")
+elseif(WIN32)
+  target_link_libraries(cherrytree "-mwindows")
+endif()
+
 set_target_properties(cherrytree PROPERTIES RUNTIME_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}")
